import javax.naming.Context;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.DirContext;
import javax.naming.directory.Attributes;
import javax.naming.directory.Attribute;
import javax.naming.NamingException;
import javax.naming.NamingEnumeration;
import java.util.Hashtable;

/**
 * Demonstrates how to retrieve an attribute of a named object.
 *
 * usage: java Getattr
 */
class Getattr {
    public static void main(String[] args) {
        // Identify service provider to use
        Hashtable env = new Hashtable(11);
        env.put(Context.INITIAL_CONTEXT_FACTORY, 
            "com.sun.jndi.ldap.LdapCtxFactory");
        env.put(Context.PROVIDER_URL, "ldap://mira.npac.syr.edu:389/o=npac.syr.edu");

        try {

            // Create the initial directory context
            DirContext ctx = new InitialDirContext(env);
            
            // Ask for all attributes of object 
            Attributes attrs = ctx.getAttributes("uid=beca,ou=People");

	    NamingEnumeration at = attrs.getAll();
            // Find the surname ("sn") and print it out
	    
	    while(at.hasMore()) {
            System.out.println("sn: " + at.next());
	  
	  	}
		
		
//	    System.out.println("sn: " + attrs.get("sn").get());
	    
	    
//	    String str = new String("irrelevant text");
	    
            attrs.put("givenname", "Luk");
	    
	    
	    ctx.modifyAttributes("uid=beca,ou=People", DirContext.REPLACE_ATTRIBUTE, attrs);
 
 	    System.out.println("attributes changed");
	    
	    attrs = ctx.getAttributes("uid=beca,ou=People");

	    at = attrs.getAll();
            // Find the surname ("sn") and print it out
	    
	    while(at.hasMore()) {
            System.out.println("sn: " + at.next());
	  
	  	}

	    
	    

        } catch (NamingException e) {
            System.err.println("Problem getting attribute: " + e);
	    e.printStackTrace();
        }
    }
}
